diff --git a/doc/asterisk.sgml b/doc/asterisk.sgml
index eed3b53..fde39d7 100644
--- a/doc/asterisk.sgml
+++ b/doc/asterisk.sgml
@@ -28,12 +28,19 @@
 <arg><option>-M </option><replaceable class="parameter">value</replaceable></arg>
 <arg><option>-U </option><replaceable class="parameter">user</replaceable></arg>
 <arg><option>-s </option><replaceable class="parameter">socket-file</replaceable></arg>
-<arg><option>-x </option><replaceable class="parameter">command</replaceable></arg>
 	</cmdsynopsis>
-	<cmdsynopsis>
 
+	<cmdsynopsis>
 	<command>asterisk -r</command>
 	<arg><option>-v</option></arg>
+	<arg><option>-d</option></arg>
+<arg><option>-x </option><replaceable class="parameter">command</replaceable></arg>
+	</cmdsynopsis>
+
+	<cmdsynopsis>
+	<command>asterisk -R</command>
+	<arg><option>-v</option></arg>
+	<arg><option>-d</option></arg>
 <arg><option>-x </option><replaceable class="parameter">command</replaceable></arg>
 	</cmdsynopsis>
 </refsynopsisdiv>
@@ -73,13 +80,22 @@
 </refsect1>
 <refsect1>
 	<title>OPTIONS</title>
+	<para>
+	Running Asterisk starts the asterisk daemon (optionally running it
+	in the foreground). However running it with <option>-r</option> or
+	<option>-R</option> connects to an existing Asterisk instance through
+	a remote console.
+	</para>
 	<variablelist>
 	<varlistentry>
 		<term>-B</term>
 		<listitem>
 			<para>
 			Force the background of the terminal to be black, in order for
-			terminal colors to show up properly.
+			terminal colors to show up properly. Equivalent to
+			<option>forceblackbackground = yes</option> in
+			<filename>asterisk.conf</filename>. See also
+			<option>-n</option> and <option>-W</option>.
 			</para>
 		</listitem>
 	</varlistentry>
@@ -96,9 +112,13 @@
 		<term>-c</term>
 		<listitem>
 			<para>
-			Provide a control console on the calling terminal.
+			Provide a control console on the calling terminal. The
+			console is similar to the remote console provided by
+			<option>-r</option>.
 			Specifying this option implies <command>-f</command> and will cause
 			asterisk to no longer fork or detach from the controlling terminal.
+			 Equivalent to <option>console = yes</option> in
+			<filename>asterisk.conf</filename>.
 			</para>
 		</listitem>
 	</varlistentry>
@@ -106,12 +126,17 @@
 		<term>-d</term>
 		<listitem>
 			<para>
-			Enable extra debugging statements.
-			</para>
-			<para>
-			Note: This always sets the debug level in the asterisk process,
-			even if it is running in the background. This may affect the size
-			of your log files, if the debug level is specified in logger.conf.
+			Enable extra debugging statements. This parameter
+			may be used several times, and each increases the debug
+			level.  Equivalent to <option>debug =
+			<replaceable>num</replaceable></option> in
+			<filename>asterisk.conf</filename> to explicitly set
+			the initian debug level to <replaceable>num</replaceable>.
+			When given at startup, this option also implies
+			<option>-f</option> (no forking). However when
+			connecting to an existing Asterisk instance
+			(<option>-r</option> or <option>-R</option>), it may
+			only increase the debug level.
 			</para>
 		</listitem>
 	</varlistentry>
@@ -121,6 +146,8 @@
 			<para>
 			Limit the generation of new channels when the amount of free memory has decreased to under <replaceable>memory</replaceable> megabytes.
 			</para>
+			 Equivalent to <option>minmemfree = <replaceable>memory</replaceable></option> in
+			<filename>asterisk.conf</filename>.
 		</listitem>
 	</varlistentry>
 	<varlistentry>
@@ -128,6 +155,9 @@
 		<listitem>
 			<para>
 			Do not fork or detach from controlling terminal.  Overrides any preceding specification of <command>-F</command> on the command line.
+			 Equivalent to <option>nofork = yes</option> in
+			<filename>asterisk.conf</filename>.
+			See also <option>-c</option>.
 			</para>
 		</listitem>
 	</varlistentry>
@@ -136,6 +166,10 @@
 		<listitem>
 			<para>
 			Always fork and detach from controlling terminal.  Overrides any preceding specification of <command>-f</command> on the command line.
+			May also be used to prevent <option>-d</option> and
+			<option>-v</option> to imply no forking.
+			 Equivalent to <option>alwaysfork = yes</option> in
+			<filename>asterisk.conf</filename>.
 			</para>
 		</listitem>
 	</varlistentry>